SystemOrganization addCategory: #'Magritte-Roe-EmbeddedObjects'!

MAMappedObject subclass: #MAEmbeddedObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Roe-EmbeddedObjects'!

MAEmbeddedObject class
	instanceVariableNames: 'List'!

MAEmbeddedObject class
	instanceVariableNames: 'List'!

!MAEmbeddedObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/8/2009 20:48'!
descriptionContainer
	^MAEmbeddedContainer new! !

!MAEmbeddedObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/8/2009 20:43'!
list
	^List ifNil: [ (List := OrderedCollection new) addAll: self loadAll ]! !

!MAEmbeddedObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/8/2009 20:44'!
load: aRelation
	^ (super load: aRelation) do: [ :each | each loadEmbedded ].
	! !

!MAEmbeddedObject methodsFor: 'as yet unclassified' stamp: 'jmck 6/8/2009 20:43'!
list
	^self class list! !

!MAEmbeddedObject methodsFor: 'as yet unclassified' stamp: 'jmck 6/8/2009 20:47'!
mementoClass
	^MAEmbeddedMemento! !

MACheckedMemento subclass: #MAEmbeddedMemento
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Roe-EmbeddedObjects'!

!MAEmbeddedMemento methodsFor: 'as yet unclassified' stamp: 'jmck 6/8/2009 21:00'!
pullRaw
	| result |
	result := Dictionary new.
	self description do: [ :each |
		each isEmbedded
			ifTrue: [ result at: each put: (each accessor next read: self model) ]
			ifFalse: [ 
				each isEmbeddedCollection 
					ifTrue: [result at: each put: (self model perform: each accessor selector) ]
					ifFalse: [ result at: each put: (self model readUsing: each) ] ] ].
	^ result! !

MAChainAccessor subclass: #MAEmbeddedAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Roe-EmbeddedObjects'!

!MAEmbeddedAccessor commentStamp: 'jmck 6/6/2009 16:19' prior: 0!
I am a ChainAccessor implementing an accessor strategy for an embedded (child) MAMappedObject. 
I read: the *id* of the object (mainly so that MARelation will write the id to the database field, instead of the object ;) 
I write:to: a model the described object (so that the model object stores my described object rather than just my object's id, natch)

Note: The read: behavior is not correct in one place, MAMemento>>pullRaw. See MARoeMemento which overrides pullRaw to accomodate this behavior!

!MAEmbeddedAccessor class methodsFor: 'instance-creation' stamp: 'jmck 6/7/2009 12:11'!
mappedTo: aSelector
	^self on: aSelector accessor: #id! !

!MAEmbeddedAccessor methodsFor: 'as yet unclassified' stamp: 'jmck 6/5/2009 23:49'!
read: aModel
	| o |
	(o := self next read: aModel) isNil ifFalse: [ ^self accessor read: o ].
	^nil! !

!MAEmbeddedAccessor methodsFor: 'as yet unclassified' stamp: 'jmck 6/7/2009 01:05'!
write: anObject to: aModel
	self next write: anObject to: aModel! !

MAPriorityContainer subclass: #MAEmbeddedContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Roe-EmbeddedObjects'!

!MAEmbeddedContainer methodsFor: 'as yet unclassified' stamp: 'jmck 6/8/2009 20:49'!
componentClass
	^MAEmbeddedContainerComponent! !

!MADescription methodsFor: '*magritte-roe-embeddedobjects' stamp: 'jmck 6/8/2009 20:59'!
beEmbedded
	self propertyAt: #embedded put: true! !

!MADescription methodsFor: '*magritte-roe-embeddedobjects' stamp: 'jmck 6/8/2009 20:59'!
beEmbeddedCollection
	self propertyAt: #embeddedCollection put: true! !

!MADescription methodsFor: '*magritte-roe-embeddedobjects' stamp: 'jmck 6/8/2009 20:58'!
embeddedAccessor: aSelector
	self accessor: (MAEmbeddedAccessor mappedTo: aSelector)! !

!MADescription methodsFor: '*magritte-roe-embeddedobjects' stamp: 'jmck 6/8/2009 20:58'!
embeddedCollectionAccessor: aSelector
	self accessor: (MAEmbeddedCollectionAccessor selector: aSelector)! !

!MADescription methodsFor: '*magritte-roe-embeddedobjects' stamp: 'jmck 6/8/2009 20:59'!
isEmbedded
	^self propertyAt: #embedded ifAbsent: [ false ]! !

!MADescription methodsFor: '*magritte-roe-embeddedobjects' stamp: 'jmck 6/8/2009 20:59'!
isEmbeddedCollection
	^self propertyAt: #embeddedCollection ifAbsent: [ false ]! !

MAContainerComponent subclass: #MAEmbeddedContainerComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Roe-EmbeddedObjects'!

!MAEmbeddedContainerComponent methodsFor: 'as yet unclassified' stamp: 'jmck 6/7/2009 15:20'!
save
	self validate ifFalse: [ ^ self ].
	self commit.
	self model save.
	self answer: self model.! !

MASelectorAccessor subclass: #MAEmbeddedCollectionAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Roe-EmbeddedObjects'!

!MAEmbeddedCollectionAccessor methodsFor: 'as yet unclassified' stamp: 'jmck 6/7/2009 16:10'!
read: aModel	
	^String streamContents: [:strm |
		strm nextPut: ${.
		((super read: aModel) collect: [ :each | each id ]) do: [ :each | 
			strm nextPutAll: each asString ] separatedBy: [ strm nextPut: $, ].
		strm nextPut: $} ].
	! !
